// This is Free Software
// See the GNU General Public License @ http://www.gnu.org/copyleft/gpl.html
// for details about the terms and conditions for using and distributing
// this piece of software.
// This software comes with absolutely NO WARRANTY!
// (c) 2003 by Daniel Gruen <daniel_gruen@web.de>

#include "qray.h"
#include "qraylight.h"

#include <qcolordialog.h>
#include <qwidget.h>

using namespace std;

/*--------------------------------------------------------*/

QRayLight::QRayLight(vektor da, QColor dc, double dintens)
 : QWidget(0,0) 
{
	a=da;
	c=dc;
	intens = dintens;
	next = 0;
}

double QRayLight::intensity(double dist)
{
	return intens * lf / ((dist/1000.0)*(dist/1000.0));
	// lf is some kind of light factor, as you have already guessed
}

void QRayLight::setIntensity(double di)
{
	intens=di;
}

void QRayLight::chooseColor()
{
	c=QColorDialog::getColor(c);
}

QRayLight::~QRayLight()
{
	if(next)
		delete next;
}

