// This is Free Software
// See the GNU General Public License @ http://www.gnu.org/copyleft/gpl.html
// for details about the terms and conditions for using and distributing
// this piece of software.
// This software comes with absolutely NO WARRANTY!
// (c) 2003 by Daniel Gruen <daniel_gruen@web.de>

#ifndef _QRAYOBJECT_
#define _QRAYOBJECT_

#include "ddd.h"
#include <qcolor.h>
#include <qobject.h>

class QRayLight;

class QRayObject : public QObject {
  Q_OBJECT
  public:
	QRayObject(vektor da, QColor dc);
	virtual ~QRayObject();
	virtual double intersects(vektor r, vektor ga);
	virtual QColor color(vektor r, double ip, QRayLight *firstl, QRayObject *firsto, vektor camera, int depth);
	vektor a,n;
	vektor u,v;
	QColor c;
	double s,t;
	QRayObject *next;
	double getS();
	double getT();
  public slots:
	void setT(double dt);
	void setS(double ds);
	void setT(int dt);
	void setS(int ds);
};

class QRayPlain : public QRayObject {
  public:
	QRayPlain(vektor da, QColor dc, vektor du, vektor dv);
	double intersects(vektor r, vektor ga);
	QColor color(vektor r, double ip, QRayLight *firstl, QRayObject *firsto, vektor camera, int depth);
};

class QRayRhomboid : public QRayObject {
  public:
	QRayRhomboid(vektor da, QColor dc, vektor du, vektor dv, double dur, double dvr);
	double ur,vr;
	double intersects(vektor r, vektor ga);
	QColor color(vektor r, double ip, QRayLight *firstl, QRayObject *firsto, vektor camera, int depth);
};

class QRayRhomboid3D : public QRayRhomboid {
  public:
	QRayRhomboid3D(vektor da, QColor dc, vektor du, vektor dv, double dur, double drv, double ddp);
};


QColor pointColor(QRayObject *self, vektor r, double ip, QRayLight *firstl, QRayObject *firsto, vektor camera, int depth);
int maxint(double x, int max);

#endif
